-- a STATIC_BODY plane factory
--[[
	xposx = params.xposx or 0, xposy = params.xposy or 0, xposz = params.xposz or 0
	xsizex = params.xsizex or 1, xsizey = params.xsizey or 1, xsizez = params.xsizez or 1
	xrotx = params.xrotx or 0, xroty = params.xroty or 0, xrotz = params.xrotz or 0
	xtexpath = params.xtexpath or "3d/texs/box.png"
	xtexw = params.xtexw or 256, xtexh = params.xtexh or 256
]]
function PLANE_3D(xworld, params)
	local matrix = Matrix.new()
	-- params
	local params = params or {}
	local xposx = params.posx or 0
	local xposy = params.posy or 0
	local xposz = params.posz or 0
	local xsizex = params.sizex or 1
	local xsizey = params.sizey or 1
	local xsizez = params.sizez or xsizex
	local xrotx = params.rotx or 0
	local xroty = params.roty or 0
	local xrotz = params.rotz or 0
	local xtexpath = params.texpath or "3d_objs/texs/box.png"
	local xtexw = params.texw or 8 * 64
	local xtexh = params.texh or 8 * 64
	-- plane mesh
	local mesh = D3.Mesh.new()
	mesh:setVertexArray{ -xsizex,xsizey,-xsizez,	xsizex,xsizey,-xsizez,	xsizex,xsizey,xsizez,	-xsizex,xsizey,xsizez }
	-- texture coordinates -- make it big (3200, 3200)
	mesh:setTextureCoordinateArray	{	0, 0,	xtexw, 0,	xtexw, xtexh,	0, xtexh	}
	-- normal array
	mesh:setGenericArray( 3, Shader.DFLOAT, 3, 4, { 0,1,0, 0,1,0, 0,1,0, 0,1,0 } )
	mesh:setIndexArray { 1,2,3,	1,3,4 }
	mesh:setTexture( Texture.new( xtexpath, true, { wrap = TextureBase.REPEAT } ) )
	-- lighting, shadows, and texture. setTexture doesn't automatically do it
	mesh:updateMode( D3.Mesh.MODE_LIGHTING | D3.Mesh.MODE_SHADOW | D3.Mesh.MODE_TEXTURE )
	-- put it in a viewport so we can matrix it
	local planeview = Viewport.new()
	planeview:setContent(mesh)
	-- transform
	matrix = planeview:getMatrix()
	matrix:setPosition(xposx, xposy, xposz)
	matrix:setRotationX(xrotx)
	matrix:setRotationY(xroty)
	matrix:setRotationZ(xrotz)
	planeview:setMatrix(matrix)
	-- body
	planeview.body = xworld:createBody(planeview:getMatrix())
	planeview.body:setType(r3d.Body.STATIC_BODY)
	planeview.shape = r3d.BoxShape.new(xsizex, xsizey, xsizez)
	local fixture1 = planeview.body:createFixture(planeview.shape, nil, 0) -- shape, transform, weight
	fixture1:setCollisionCategoryBits(NONDESTRUCTIBLES)
	fixture1:setCollideWithMaskBits(PLAYER1+MISSILES+DESTRUCTIBLES)
	xworld.staticbodies[#xworld.staticbodies + 1] = planeview
end
